Subject: Re: linux-next: build problem with nfs tree (Was: Re: [mmotm][PATCH] fix ia64 build error)

From: Andrew Morton <[email-masked]>
Date: Thu, 15 Jan 2009 17:59:17 -0800

On Fri, 16 Jan 2009 12:49:49 +1100 Stephen Rothwell <[email-masked]> wrote:

> Hi Andrew,
> 
> On Thu, 15 Jan 2009 09:35:14 -0800 Andrew Morton <[email-masked]> wrote:
> >
> > On Thu, 15 Jan 2009 20:05:08 +0900 (JST) KOSAKI Motohiro <[email-masked]> wrote:
> > 
> > > Applied after: linux-next.patch
> > > ==
> > > Subject: [PATCH] remove duplicate EXPORT_SYMBOL()
> > > Impact: fix build error
> > > 
> > > In past, ia64_ksyms.c had EXPORT_SYMBOL(copy_page) in wrong place.
> > > 
> > > old code was
> > > 
> > > 	#include <asm/uaccess.h>
> > > 	EXPORT_SYMBOL(__copy_user);
> > > 	EXPORT_SYMBOL(__do_clear_user);
> > > 	EXPORT_SYMBOL(__strlen_user);
> > > 	EXPORT_SYMBOL(__strncpy_from_user);
> > > 	EXPORT_SYMBOL(__strnlen_user);
> > > 	EXPORT_SYMBOL(copy_page);
> > > 
> > > (but actually, copy_page is declared in asm/page.h)
> > > 
> > > And recently, commit bdc2619ab95d45d434c16d5c216bc6243761f6fb insert
> > > EXPORT_SYMBOL(copy_page) into correct place.
> > > 
> > > then, duplicate EXPORT_SYMBOL create following build error.
> > > 
> > > arch/ia64/kernel/ia64_ksyms.c:65: error: redefinition of '__kcrctab_copy_page'
> > > arch/ia64/kernel/ia64_ksyms.c:43: error: previous definition of '__kcrctab_copy_page' was here
> > > arch/ia64/kernel/ia64_ksyms.c:65: error: redefinition of '__kstrtab_copy_page'
> > > arch/ia64/kernel/ia64_ksyms.c:43: error: previous definition of '__kstrtab_copy_page' was here
> > > arch/ia64/kernel/ia64_ksyms.c:65: error: redefinition of '__ksymtab_copy_page'
> > > arch/ia64/kernel/ia64_ksyms.c:43: error: previous definition of '__ksymtab_copy_page' was here
> > 
> > Yes, this is a strange bug added by
> > 
> > commit 7aed50e09223e7623c7ab826efd53f097bed2f73
> > Author:     Prarit Bhargava <[email-masked]>
> > AuthorDate: Sat Jan 10 02:25:44 2009 +0000
> > Commit:     David Howells <[email-masked]>
> > CommitDate: Sat Jan 10 02:25:44 2009 +0000
> > 
> >     CacheFiles: Add missing copy_page export for ia64
> > 
> > I don't see how it could have been tested :(
> > 
> > I also don't know which linux-next tree added that commit.  There's a
> > way of working this out but I forgot it.
> 
> In gitk you can search backwards for a merge commit containing "sfr" :-)

I do most of my gitting across a DSL connection.  It makes GUIs
painful.

> I have dropped the nfs tree from linux-next for today.

Just for this buglet?  That sounds a bit savage.